.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

LOOP_COUNT	= 12345		; will be in ST(6) - timers use the FPU

.data
MyReal10		dt	-1		; to produce a NaN

.code
start:	finit
	ct = 9
	REPEAT 9-5
		ct = ct - 1
		tmp$ CATSTR <push >, %ct, %ct, %ct, %ct, %ct, %ct, %ct, %ct, %ct
		tmp$
		fild dword ptr [esp]
	ENDM
	add esp, 10*4
;	int 3		; for Olly
	fincstp		; we now have a nicely filled FPU with a bad ST(7)

	fdecstp
	ffree st(0)	; rotate the barrel, free ST
	fincstp		; (rotate back for next test below)

	fldz
	ffree st(0)	; push a zero, free ST
	fincstp		; (rotate back for next test below)

	fdecstp
	ffree st(0)	; rotate the barrel, free ST
	fstp ST		; (pop ST for next test below)

	fldz
	ffree st(0)	; push a zero, free ST
	fstp ST		; (pop ST for next test below...)

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;	int 3
		REPEAT 100
			fdecstp
			ffree st(0)
			fincstp
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*fdecstp, fincstp", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;	int 3
		REPEAT 100
			fldz
			ffree st(0)
			fincstp
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*fldz, fincstp", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;	int 3
		REPEAT 100
			fdecstp
			ffree st(0)
			fstp ST
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*fdecstp, fstp ST", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;	int 3
		REPEAT 100
			fldz
			ffree st(0)
			fstp ST
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*fldz, fstp ST", 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]